#include <stdio.h>
#include <getopt.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define STR_MAX_SIZE 256  // taille maximale tolre pour les chanes de caractres

    /* Affichage d'un message d'erreur sur la sortie d'erreur standard et quitte */
void printError(char * msg) {
    fprintf(stderr, "[ERREUR] %s\n",msg);
    exit(EXIT_FAILURE);
}
    /* Affichage du message d'aide et quitte */
void usage(char * command) {
    printf("%s [-i val_i] [-f val_f] [-s string] [-k key] [-h] file\n", command);
    exit(EXIT_SUCCESS);
}

int main(int argc, char * argv[]) 
{
    extern char *optarg;  // spcifique  getopt
    extern int optind;    // idem
    char c;     
    /* Variables modifiables par les options de la ligne de commande. */
    int   opt_i = 14; 
    float opt_f = 1.5;
    char  opt_s[STR_MAX_SIZE] = "On est super content!";
    unsigned long opt_k = 0x90ABCDEF; 
    char  input_file[STR_MAX_SIZE];

    while ((c = getopt(argc, argv, "i:f:s:k:h")) != -1) {
        if ((optarg != NULL) && (optarg[0] == '-')) printError("Mauvais format");
        switch(c) {
          case 'h': usage(argv[0]); return EXIT_SUCCESS; 
          case 'i': 
            opt_i = (int) strtol(optarg, NULL, 10);
            break;
          case 'f': 
            opt_f = (float) strtod(optarg, NULL);
            break;
          case 's':
            assert(strlen(optarg) < STR_MAX_SIZE); 
            strncpy(opt_s, optarg, STR_MAX_SIZE);
            break;
          case 'k':
            opt_k = (unsigned long) strtol(optarg, NULL, 16);
            break;
          default: printError("option non reconnue!");
        } 
    }
    if ((argc - optind) != 1) printError("l'argument file est obligatoire!");
    // On peut maintenant rcuprer le dernier paramtre.
    assert(strlen(argv[optind]) < STR_MAX_SIZE);
    strncpy(input_file, argv[optind], STR_MAX_SIZE);

    // Affichage final.
    printf("opt_i : %d\n",  opt_i);
    printf("opt_f : %f\n",  opt_f);
    printf("opt_s : %s\n",  opt_s);
    printf("opt_k : %lx\n", opt_k);
    printf("input_file : %s\n", input_file);
    return 0;
}
