#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 50             // Taille maximale d'une chaine de caractres
#define MAX_PERS 100            // Taille maximale de l'annuaire
#define ANNUAIRE "annuaire.txt" // Le nom du fichier sauvegardant l'annuaire

struct personne {
    char nom[STR_SIZE], prenom[STR_SIZE], tel[STR_SIZE];
    int age;
};

void error(char * msg) { // Affiche d'un message d'erreur et sortie.
    perror(msg);
    exit(EXIT_FAILURE);
}

int main()
{
    struct personne tab[MAX_PERS] = {
	{"Varrette", "Sbastien", "+33 (0)0 11 22 33 44", 26},
	{"Bernard",  "Nicolas",   "+33 (0)0 55 66 77 88", 25},
	{"", "", "", -1} // Entre spciale qui indique la fin de l'annuaire.
    };

        /* Sauvegarde de l'annuaire. */
    FILE * fich = fopen(ANNUAIRE, "w");
    if ( fich == NULL ) error("[Erreur] fopen (write)");
    
    fseek(fich, 2, SEEK_SET);
    uint16_t i = 0;
    while (strlen(tab[i].nom) > 0) {
	fwrite(&tab[i], sizeof(struct personne), 1, fich);
	i++;
    }
    fseek(fich, 0, SEEK_SET);
    fwrite(&i, 2, 1, fich);
    fclose(fich);
    
        /* Rcupration des donnes sauvegardes. */
    struct personne buffer;
    uint16_t nb_pers = 0; // Nombre de personnes dans l'annuaire.
    fich = fopen(ANNUAIRE, "r");
    if ( fich == NULL ) error("[Erreur] fopen (write)");
    
    fread(&nb_pers, 2, 1, fich);
    for (int i = 0; i < nb_pers; i++) {
	if (fread(&buffer, sizeof(struct personne), 1, fich) != 1) break;
	printf("Entre %d\n", i + 1);
	printf("\t %s %s (age: %d) -->  %s\n",
	       buffer.nom, buffer.prenom, buffer.age, buffer.tel);
    }
    fclose(fich);
    return 0;
}
