#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

sig_atomic_t tubekaput = 0;

static void traiteSIGPIPE(int n) {
	tubekaput = 1;
}

void ecrireverif(int desc, char c, char *prog) {
	write(desc, &c, 1);
	if (tubekaput) {
		close(desc);
		wait(NULL); /* pour ne pas avoir de zombie */
		execlp(prog, prog, &c, NULL);
		exit(EXIT_FAILURE);
	}
}

int main(int argc, char *argv[])
{
	char c;
	int descfich[2];

	sigset_t mask;
	struct sigaction gestionnaire;
	gestionnaire.sa_handler = traiteSIGPIPE;
	gestionnaire.sa_flags = 0;
	if (sigemptyset(&mask))          		return EXIT_FAILURE;
	if (sigaction(SIGPIPE, &gestionnaire, NULL))	return EXIT_FAILURE;
	if (pipe(descfich))	                        return EXIT_FAILURE;

	switch (fork()) {
	case -1:
		return EXIT_FAILURE;
	case 0: /* fils */
		close(descfich[1]);
		while(read(descfich[0], &c, 1) == 1) {
			putchar(c);
		}
		return 0;
	default: /* pre */
		close(descfich[0]);
		if (argc == 2) /* il y a un caractre que l'on n'a pas crit...*/
			ecrireverif(descfich[1], argv[1][0], argv[0]);
		while (read(STDIN_FILENO, &c, 1) == 1) {
			ecrireverif(descfich[1], c, argv[0]);
		}
		return 0;
	}
}
