#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>

#include "printtools.h"

int main()
{
	int sockfd;
	struct sockaddr_in server;
	server.sin_family      = AF_INET;
	server.sin_port        = 6666;
	server.sin_addr.s_addr = htonl(INADDR_ANY); // wildcard

	// Cration d'une socket.
	if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		perror("[socket]");
		exit(EXIT_FAILURE);
	}
	// Attachement  l'adresse serveur.
	if (bind(sockfd, (struct sockaddr *) &server, sizeof(server))) {
		perror("[bind]");
		exit(EXIT_FAILURE);
	}
	// ...
	print_ipv4(&server);

	// Test de getsockname.
	struct sockaddr_in server_info;
	socklen_t addrlen = sizeof(server_info);
	if (getsockname(sockfd, (struct sockaddr *)&server_info, &addrlen))
		perror("[getsockname]");
	else print_ipv4(&server_info);

	close(sockfd);
	return EXIT_SUCCESS;
}

