/*********************************************************************
 *             This file is a part of True Nyms.                     *
 *            See the LICENSE file for copyright.                    *
 *********************************************************************/

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

/** sock doit tre une socket Unix. */
int retrievefd(int sock) {
	int fd = -1;
	unsigned char* databuf[1] = {0};

	struct iovec vec = {0};
	vec.iov_base = databuf;
	vec.iov_len = 1;

	struct msghdr msg = {0};
	char buf[CMSG_SPACE(sizeof fd)];  /* Ancillary data buffer. */
	msg.msg_name = NULL;
	msg.msg_namelen = 0;
	msg.msg_iov = &vec;
	msg.msg_iovlen = 1;
	msg.msg_control = buf;
	msg.msg_controllen = sizeof buf;

	int err = recvmsg(sock, &msg, 0);
	if (err < 0) {
		fprintf(stderr, "retrievefd: recvmsg: %s", strerror(errno));
		exit(1);
	}

	struct cmsghdr *cmsg;
	cmsg = CMSG_FIRSTHDR(&msg);
	if (cmsg == NULL || cmsg->cmsg_type != SCM_RIGHTS) {
		return -1;
	}
	int *fdptr = (int *)CMSG_DATA(cmsg);
	fd = *fdptr;

	return fd;
}

/** sock doit tre une socket Unix. */
int sendfd(int sock, int fd) {
	struct msghdr msg = {0};
	struct cmsghdr *cmsg;

	char buf[CMSG_SPACE(fd)];  /* Ancillary data buffer. */
	int *fdptr;

	unsigned char databuf[1] = {0};
	struct iovec vec = {0};
	vec.iov_base = databuf;
	vec.iov_len = 1;

	databuf[0] = (unsigned char) 1;

	msg.msg_control = buf;
	msg.msg_controllen = sizeof(buf);
	msg.msg_iov = &vec;
	msg.msg_iovlen = 1;
	cmsg = CMSG_FIRSTHDR(&msg);
	cmsg->cmsg_level = SOL_SOCKET;
	cmsg->cmsg_type = SCM_RIGHTS;
	cmsg->cmsg_len = CMSG_LEN(sizeof(int));
	fdptr = (int *)CMSG_DATA(cmsg);
	*fdptr = fd;
	msg.msg_controllen = cmsg->cmsg_len;

	int err = sendmsg(sock, &msg, 0);
	if (err < 0) {
		fprintf(stderr, "sendmsg: %s", strerror(errno));
		return -1;
	}
	return 0;
}


int
main()
{
	return 0;
}
