#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>

void print_hostent_info(struct hostent * hp); //  cf listing /*@\ref{network::hostent}@*/

int main( int argc, char* argv[]) 
{
    extern int h_errno;
    struct hostent* hp;
    if ( argc != 2) {
	fprintf(stderr, "Usage: %s <host_name>|<host_addr>\n",argv[0]);
	return EXIT_FAILURE;
    }
    if (( hp = gethostbyname(argv[1])) == NULL) {
	fprintf(stderr, "[Erreur] gethostbyname : %s\n", hstrerror(h_errno));
	return EXIT_FAILURE;
    }
    print_hostent_info(hp);
    return EXIT_SUCCESS;
}

void print_hostent_info(struct hostent * hp) {
    unsigned int i,j;

         // Gestion du champ hp->h_name (nom officiel de l'hte)
    printf("Champ h_name     : %s\n",
	   (hp->h_name == NULL)?"NULL":hp->h_name);
         // Gestion du champ hp->h_aliases (liste d'alias)
    if (hp->h_aliases != NULL && *hp->h_aliases != NULL) {
	i = 0;
	printf( "Champ h_aliases  :");
	do {
	    printf( " %s", hp->h_aliases[i]);
	    i++;
	} while (hp->h_aliases[i] != NULL);
	printf("\n");
    }
         // Gestion du champ hp->h_addrtype (type d'adresse)
    printf( "Champ h_addrtype : %d (%s)\n",
	    hp->h_addrtype, 
	    (hp->h_addrtype == AF_INET)?"AF_INET":"!AF_INET");
         // Gestion du champ hp->h_length (longueur d'adresse- 4 pour IPv4)
    printf( "Champ h_length   : %d\n", hp->h_length);
         // Gestion du champ hp->h_addr_list (liste des adresses renvoyes)
    printf( "Champ h_addr_list: \n");
    for( i = 0 ; hp->h_addr_list[i] != NULL; i++) {
	printf("  [%d] ",i);
	for ( j = 0; j < hp->h_length; j++) 
	    printf( "%02x", hp->h_addr_list[i][j]);
	printf( "(%s)\n", inet_ntoa( * (struct in_addr *)( hp->h_addr_list[i]) ));
    }
}
