#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#define __USE_MISC 1
#include <arpa/inet.h>

int main(int argc, char* argv[]) 
{
    struct in_addr addr_by_aton, addr_by_addr; 
    if ( argc != 2) {
	fprintf(stderr, "Usage: %s <adresse IP>\n",argv[0]);
	return EXIT_FAILURE;
    }
        // Rcupration de l'adresse dans addr par inet_aton
    if ( !(inet_aton(argv[1], &addr_by_aton)) ) {
	fprintf(stderr, "Format invalide d'adresse (%s)\n",argv[1]);
    }
        // Rcupration de l'adresse dans addr par inet_addr
    if ( (addr_by_addr.s_addr = inet_addr(argv[1])) == INADDR_NONE) {
	fprintf(stderr, "inet_addr a chou sur l'adresse %s\n",argv[1]);
	return EXIT_FAILURE;
    }
    printf("Adresse rcupre par inet_aton %02x (%s)\n", 
	   addr_by_aton.s_addr, argv[1]);
    printf("Adresse rcupre par inet_addr %02x (%s)\n", 
	   addr_by_addr.s_addr, argv[1]);
        // Rcupration de la chaine de caractre via inet_ntoa pour affichage
    printf("Affichage via inet_ntoa : %s\n", inet_ntoa(addr_by_aton));
    return EXIT_SUCCESS;
}
