#include <stdio.h>     
#include <stdlib.h>
#define __USE_MISC 1
#include <arpa/inet.h>
#include <sys/socket.h>
#include <netinet/in.h>

int main() 
{
    short int i;
    char tmp[INET6_ADDRSTRLEN];
    struct in_addr  addr_ipv4; 
    struct in6_addr addr_ipv6;
    char * addr4      = "192.168.0.14";             // Adresse IPv4
    char * addr_mixte = "::192.168.0.14";           // Adresse IPv4 compatible IPv6
    char * addr6      = "8000::ABC:DEF1:2345:6789"; // Adresse IPv6

        // Rcupration de l'adresse IPv4 par inet_aton
    if ( inet_aton(addr4, &addr_ipv4) ) 
	printf("Adresse IPv4 rcupre par inet_aton: %02x\n", addr_ipv4.s_addr);
        
        // Nouvelle version : rcupration de l'adresse IPv4 par inet_pton
    if ( inet_pton(AF_INET, addr4, &addr_ipv4) > 0)
	printf("Adresse IPv4 rcupre par inet_pton: %02x\n", addr_ipv4.s_addr);

        // Rcupration de l'adresse IPv4 compatible IPv6 par inet_pton
    if ( inet_pton(AF_INET6, addr_mixte, &addr_ipv6) > 0) {
	printf("Adresse IPv4 rcupre dans une structure IPv6 "
	       "par inet_pton:\n   ");
	for (i=0; i<16; i++) printf("%02x", addr_ipv6.s6_addr[i]);
	// Affichage  partir de inet_ntop
	if (inet_ntop(AF_INET6, &addr_ipv6, tmp, INET6_ADDRSTRLEN))
	    printf("\nAffichage en notation standard: %s\n", tmp);
    }   
        // Rcupration de l'adresse IPv6 par inet_pton
    if ( inet_pton(AF_INET6, addr6, &addr_ipv6) > 0) {
	printf("Adresse IPv6 rcupre par inet_pton:\n   ");
	for (i=0; i<16; i++) printf("%02x", addr_ipv6.s6_addr[i]);
	// Affichage  partir de inet_ntop
	if (inet_ntop(AF_INET6, &addr_ipv6, tmp, INET6_ADDRSTRLEN))
	    printf("\nAffichage en notation standard: %s\n", tmp);
    }
    return EXIT_SUCCESS;
}

