/**
 * @file   printtools.h
 * @author Sebastien Varrette <Sebastien.Varrette@imag.fr>
 * @date   Fri Oct 13 2006  
 *
 * @brief  Useful functions, in particular to convert data to/from  string
 */
 /********************************************************************************/
#ifndef __TOOLS_H
#define __TOOLS_H
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <string.h>    
#include <stdlib.h>
#define _POSIX_C_SOURCE 2
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void print_flags(int f) {
    switch (f) {
    case AI_PASSIVE:     printf("AI_PASSIVE");     break;
    case AI_CANONNAME:   printf("AI_CANONNAME");   break;
    case AI_NUMERICHOST: printf("AI_NUMERICHOST"); break;
    default: printf("%d Unknown",f);
    }
}

void print_family(int af) {
    switch (af) {
    case AF_INET:  printf("AF_INET");  break;
    case AF_INET6: printf("AF_INET6"); break;
    case AF_LOCAL: printf("AF_LOCAL"); break;
    default: printf("%d Uncommon",af);
    }
}

void print_socktype(int s) {
    switch (s) {
    case SOCK_STREAM: printf("SOCK_STREAM"); break;
    case SOCK_DGRAM:  printf("SOCK_DGRAM");  break;
    default: printf("%d Uncommon",s);
    }
}

void print_protocol(int p) {
    switch (p) {
    case IPPROTO_IP:   printf("IPPROTO_IP");   break;
    case IPPROTO_TCP:  printf("IPPROTO_TCP");  break;
    case IPPROTO_UDP:  printf("IPPROTO_UDP");  break;
    case IPPROTO_RAW:  printf("IPPROTO_RAW:"); break;
    case IPPROTO_ICMP: printf("IPPROTO_ICMP"); break;
    default: printf("%d Uncommon",p);
    }
}
void print_ipv4(struct sockaddr_in * addr) {
    	print_family(addr->sin_family);  
#ifndef __GLIBC__   /* La glibc ne dfini pas le champ sin_len */
	printf("(taille: %d) ", addr->sin_len);
#endif
	char str_addr[INET6_ADDRSTRLEN], *ptr; 
	ptr = (char *) inet_ntop(AF_INET, &addr->sin_addr, str_addr, sizeof(str_addr));
	if (ptr != NULL) printf("\t@IP -> %s\t port : %d\n",str_addr,addr->sin_port);
}


#endif   // __TOOLS_H
