#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#define _POSIX_C_SOURCE 2
#include <netdb.h>
#include <string.h>
#include "printtools.h"

#define MAX_SIZE 256
#define GROUP   "239.15.10.06"  // Format: 239.jj.mm.yy
#define NUMPORT 6666

void error(char * msg);
int main() 
{
    int sockfd = socket(PF_INET, SOCK_DGRAM, 0); // initialisation classique
    if (sockfd < 0) error("[socket]");

    struct sockaddr_in ip_mcast; // adresse de multicast du groupe (@IP+port)
    memset(&ip_mcast, 0, sizeof(ip_mcast));
    ip_mcast.sin_family      = AF_INET;
    if (inet_pton(AF_INET, GROUP, &(ip_mcast.sin_addr)) < 0) error("[inet_pton]");
    ip_mcast.sin_port        = htons(NUMPORT);    
 
    // Pour envoyer: il suffit d'envoyer  l'adresse du groupe
    char msg[] = "PING";
    ssize_t n = sendto(sockfd, msg, sizeof(msg), 0, 
		       (struct sockaddr *) &ip_mcast, sizeof(ip_mcast));
    if (n != sizeof(msg)) error("[sendto]");

    close(sockfd);
    return EXIT_SUCCESS;
}

void error(char * msg) {
    perror(msg);
    exit(EXIT_FAILURE);
}
