#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <string.h>    
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MAX_SIZE 256
#define NUMPORT  6666    // Le port o les utilisateurs se connecteront 

void error(char * msg);  // cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/
void traitement(int desc_sock); 
int main()               /*** SERVEUR UDP ***/
{
	int desc_sock;
	struct sockaddr_in adr_svr;   // Pour l'adresse IP locale du serveur.

	memset(&adr_svr, 0, sizeof(adr_svr)); // Initialisation de la structure.
	adr_svr.sin_family      = AF_INET;
	adr_svr.sin_addr.s_addr = htonl(INADDR_ANY);
	adr_svr.sin_port        = htons(NUMPORT);

        /*** Cration de la socket. ***/
	if ((desc_sock = socket(PF_INET,SOCK_DGRAM,0)) == -1)
		error("[socket]");

        /*** Attachement de la socket. ***/
	if (bind(desc_sock, (struct sockaddr *) &adr_svr, sizeof(adr_svr)))
		error("[bind]");

	while(1) // Boucle principale pour traitement.
		traitement(desc_sock);
	return EXIT_SUCCESS;
}

void error(char * msg) {
	perror(msg);
	exit(EXIT_FAILURE);
}

void traitement(int desc_sock) {
	char requete[MAX_SIZE+1], reponse[MAX_SIZE] = "Nonnnnnnnnn !";
	size_t answer_size = strlen(reponse)+1;
	struct sockaddr_in cl_addr;
	memset(&cl_addr, 0, sizeof(cl_addr)); // Initialisation de la structure.
	socklen_t lon = sizeof(cl_addr);  // Ne pas oublier d'initialiser lon!!!

	ssize_t n = recvfrom(desc_sock, requete, MAX_SIZE-1, 0, // Rception.
			     (struct sockaddr *)&cl_addr, &lon);
	if (n < 0) error("[recvfrom]");
	requete[MAX_SIZE] = '\0';
	printf(" - Requte reue de %s:%d : <%s> (%ld octets reus)\n", 
	       inet_ntoa(cl_addr.sin_addr), ntohs(cl_addr.sin_port),
	       requete, (long) n);

	n = sendto(desc_sock, reponse, answer_size, 0, // mission de la rponse.
		   (struct sockaddr *) &cl_addr, lon);
	if ( n != answer_size ) error("[sendto]");
	printf(" - Rponse mise: <%s> (%ld octets envoys)\n", reponse, (long) n);
}
