#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h> 
#include <string.h>
#define __USE_MISC 1
#include <sys/un.h>    

#define TAILLE_MAX 256

void error(char * msg);      // cf. ligne /*@\ref{network::socket_TCP_client::error} du listing~\ref{network::socket_TCP_client}@*/
void doit(int desc_sock, struct sockaddr_un * serv); // cf.

// [...]
#define CHEMIN_SERVEUR "/tmp/server.socket"  // Chemin de la socket serveur.

int main(int argc, char* argv[])
{
	char * chem_svr = CHEMIN_SERVEUR;
	struct sockaddr_un adr_svr;

	switch (argc) { // Traitement des arguments de la ligne de commande.
	case 2:  chem_svr = argv[1];
	case 1:  break;
	default: fprintf(stderr, "Usage: %s [server_path]\n",argv[0]);
		return EXIT_FAILURE;
	}

	/*** Construction de l'adresse du serveur. ***/
	memset(&adr_svr, 0, sizeof(adr_svr)); // Remplissage  0.
#ifndef __GLIBC__   /* La glibc ne dfinit pas le champ sun_len. */
	adr_svr.sun_len    = sizeof(adr_svr);
#endif
	adr_svr.sun_family = AF_LOCAL;
	strncpy(adr_svr.sun_path, chem_svr, sizeof(adr_svr.sun_path)-1);
	adr_svr.sun_path[sizeof adr_svr.sun_path  - 1] = 0;

	/*** Cration de la socket. ***/
	int desc_sock = socket(AF_LOCAL,SOCK_STREAM,0);
	if (desc_sock == -1)   error("[socket]");

	/*** Connexion au serveur. ***/
	if (connect(desc_sock, (struct sockaddr *) &adr_svr, SUN_LEN(&adr_svr)))
		error("[connect]");
	doit(desc_sock, &adr_svr);

	/*** Fermeture de la socket. ***/
	close(desc_sock);
	return EXIT_SUCCESS;
}

/*** Gestion des interactions avec le serveur ***/
void doit(int desc_sock, struct sockaddr_un * serv)
{
	char requete[TAILLE_MAX] = "Luc, je suis ton pre!";
	char reponse[TAILLE_MAX+1];
	size_t request_size = strlen(requete) + 1;

	ssize_t n = send(desc_sock, requete, request_size, 0); // Envoi de la requte.
	if (n != request_size) error("[send]");
	printf("Requte envoye  %s : <%s> (%ld octets)\n", serv->sun_path, requete, (long) n);

	n = recv(desc_sock, reponse, TAILLE_MAX-1, 0); // La rponse du serveur.
	if (n < 0) error("[recv]");
	reponse[TAILLE_MAX] = '\0'; // Prcaution pour l'affichage.
	printf("Rponse obtenue: <%s> (%ld octets)\n", reponse, (long) n);
}

void error(char * msg)
{
	perror(msg);
	exit(EXIT_FAILURE);
}

/*
  char requete[TAILLE_MAX] = "Luc, je suis ton pre!";
  ssize_t numoctet_env = send(desc_sock, requete, strlen(requete)+1, 0);
  if (numoctet_env < 0) error("[send]");
  
  printf("Requte envoye  %s: <%s> (%lu octets)\n",
  adr_svr.sun_path, requete, numoctet_env);
  
  char reponse[TAILLE_MAX];
  ssize_t numoctet_recu = recv(desc_sock, reponse, TAILLE_MAX, 0);
  if (numoctet_recu < 0) error("[recv]");
  printf("Rponse obtenue: <%s> (%lu octets)\n",reponse, numoctet_recu);
*/
